extends Node

# This tells the game what the logmode is.
# 0 -> None
# 1 -> Errors
# 2 -> Errors/Warnings
# 3 -> Errors/Warnings/Infos
# 4 -> All
var logmode: int = 4

func test() -> void:
	debug("Test")
	info("Test")
	warning("Test")

# Used for errors.
func error(message: String, alert_message: String) -> void:
	if message == "":
		message = "Empty message string passed to an error message!"
	if logmode >= 1:
		printerr("[ERROR] " + message)
		OS.alert(alert_message, "Error!")
		if OS.shell_open(OS.get_user_data_dir()) != OK:
			Log.warning("Couldn't open file explorer!")
	else:
		OS.alert("An error has occured. The program will now exit.", "Error!")
	get_tree().quit()

# Used for warnings.
func warning(message: String) -> void:
	if message == "":
		message = "Empty message string passed to a warning message!"
	if logmode >= 2:
		printerr("[WARNING] " + message)

# Used for simple info.
func info(message: String) -> void:
	if message == "":
		warning("Empty message string passed to an info message!")
		return
	if logmode >= 3:
		print("[INFO] " + message)

# Used for debugging.
func debug(message: String) -> void:
	if message == "":
		warning("Empty message string passed to a debug message!")
		return
	if logmode >= 4:
		print("[DEBUG] " + message)
